#include <RF24Network.h>
#include <RF24.h>
#include <SPI.h>
#include <SHT1x.h>

// Specify data and clock connections and instantiate SHT1x object
#define dataPin  18
#define clockPin 19
SHT1x sht1x(dataPin, clockPin);

int sid=1;
int nid=2;

// nRF24L01(+) radio attached using Getting Started board 
RF24 radio(9,10);
// Network uses that radio
RF24Network network(radio);

// Address of our node
const uint16_t this_node = 1;
// Address of the other node
const uint16_t other_node = 0;

// How often to send 'hello world to the other unit
const unsigned long interval = 2000; //ms

// When did we last send?
unsigned long last_sent;

// How many have we sent already
unsigned long packets_sent;

// Structure of our payload
struct payload_t
{
  unsigned long ms;
  unsigned long counter;
  char sendchar[20];
};

  float temp_c;
  float temp_f;
  float temp_humidity;

int humdity=0;
int temperature=0;
  
char sendchar[20]={0};

void setup(void)
{
  Serial.begin(9600);
  Serial.println("RF24Network/TX");
 
  SPI.begin();
  radio.begin();
  network.begin(/*channel*/ sid, /*node address*/ this_node);
  
  
  Serial.println("setup success"); 
}

void loop(void)
{
  // Pump the network regularly
  network.update();

  // If it's time to send a message, send it!
  unsigned long now = millis();
  if ( now - last_sent >= interval  )
  {
    last_sent = now;

//    //dat=(125*analogRead(1))>>8;
//    Serial.print("Tep:");
//    Serial.print( analogRead(1) );
//    Serial.println("C");

    run_sht10();
    
    Serial.print("Sending...");
    if(packets_sent>1000000) packets_sent=0;
    
    get_send_char(sid,nid,humdity,temperature,sendchar);//"{ck001001100000}"
    Serial.print(sendchar);
    payload_t payload = {sid, packets_sent++,"{ck001002000000}"};// millis()
    sprintf(payload.sendchar,"%s",sendchar);
    RF24NetworkHeader header(/*to node*/ other_node);
    bool ok = network.write(header,&payload,sizeof(payload));
    if (ok)
      Serial.println("ok.");
    else
      Serial.println("failed.");
  }
}

void get_send_char(int sid,int nid,int humdity,int temperature,char *p){    
  sprintf(p,"{ck%.3d%.3d%d.%d}",sid,nid,humdity,temperature); 
}



void run_sht10()
{
  
  temp_c = sht1x.readTemperatureC();
  temp_humidity = sht1x.readHumidity();
  humdity=(int)temp_humidity;
  temperature=(int)temp_c;  
  
}
